<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入衣服颜色名称" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" @click="handleAdd" v-hasPermi="['cloth:color:add']">新增</el-button>
      </el-col>

      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <Page uri="/mapi/core/color/list" :request-params="queryParams" ref="pagination">
      <el-table-column label="ID" align="center" prop="id" />
      <el-table-column label="衣服颜色名称" align="center" prop="name" />
      <el-table-column label="颜色" align="center" prop="code">
        <template slot-scope="scope">
          <el-color-picker v-model="scope.row.code" :show-alpha="false" :color-format="'hex'" disabled v-if="scope.row.colorType == '0'">
          </el-color-picker>
          <el-image style="width: 35px; height: 35px" fit="cover" :src="scope.row.imgUrl" :preview-src-list="[scope.row.imgUrl]"
            v-if="scope.row.colorType == '1'">
          </el-image>
        </template>
      </el-table-column>
      <el-table-column label="显示顺序" align="center" prop="sort" />
      <el-table-column label="状态" align="center" key="status">
        <template slot-scope="scope">
          <el-switch v-model="scope.row.status" active-value="0" inactive-value="1" @change="handleStatusChange(scope.row)"></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['cloth:color:edit']">修改</el-button>
          <el-button type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-hasPermi="['cloth:color:remove']">删除</el-button>
        </template>
      </el-table-column>
    </Page>

    <!-- 添加或修改衣服颜色对话框 -->
    <el-dialog :title="title" :visible.sync="open" direction="rtl" size="30%" append-to-body @opened="onDialogOpened" destroy-on-close>
      <el-row :gutter="15">
        <el-form ref="form" :model="form" :rules="rules" size="medium" label-width="100px">
          <el-form-item label="颜色名称" prop="name">
            <el-input v-model="form.name" placeholder="请输入衣服颜色名称" />
          </el-form-item>
          <el-form-item label="颜色类别" prop="colorType">
            <el-radio-group v-model="form.colorType" size="small">
              <el-radio-button v-for="dict in dict.type.cloth_color_type" :label="dict.value">{{dict.label}}</el-radio-button>
            </el-radio-group>
          </el-form-item>
          <el-form-item label="颜色代码" prop="code" v-if="form.colorType == '0'">
            <el-color-picker v-model="form.code" :show-alpha="false" :color-format="'hex'">
            </el-color-picker>
          </el-form-item>
          <el-form-item label="颜色图片" prop="imgUrl" v-if="form.colorType == '1'">
            <el-upload class="image-uploader" :action="uploadAction" :before-upload="handleBeforeUpload" :on-success="handleUploadSuccess"
              :on-error="handleUploadError" accept="image/*" :show-file-list="false">
              <img v-if="form.imgUrl" :src="form.imgUrl">
              <i v-else class="el-icon-plus image-uploader-icon"></i>
            </el-upload>
          </el-form-item>
          <el-form-item label="显示顺序" prop="sort">
            <el-input-number v-model="form.sort" placeholder="请输入显示顺序(升序排列显示)" :min="0" :step-strictly="true" :style="{width: '100%'}">
            </el-input-number>
          </el-form-item>
          <el-form-item label="状态" prop="status">
            <el-radio-group v-model="form.status" size="small">
              <el-radio-button v-for="dict in dict.type.sys_normal_disable" :label="dict.value">{{dict.label}}</el-radio-button>
            </el-radio-group>
          </el-form-item>
        </el-form>
      </el-row>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm" style="margin-left: 5%">提交</el-button>
        <el-button @click="closeDialog">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listColor,
  getColor,
  delColor,
  addColor,
  updateColor,
  changeColorStatus
} from "@/api/core/color";

export default {
  name: "Color",
  dicts: ['sys_normal_disable', 'cloth_color_type'],
  data() {
    return {
      uploadAction: `${process.env.VUE_APP_BASE_API}` + '/common/uploadOSS',
      dialogLoading: true,
      loadingText: '查询中',
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 衣服颜色表格数据
      colorList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        name: null,
        code: null,
        picUrl: null,
        sort: null,
        status: null,
        createById: null,
        updateById: null,
      },
      // 表单参数
      form: {
        colorType: '0',
        status: '0'
      },
      // 表单校验
      rules: {
        name: [{
          required: true,
          message: "衣服颜色名称不能为空",
          trigger: "blur"
        }],
        code: [{
          required: true,
          message: "衣服颜色编码不能为空",
          trigger: "blur"
        }]
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    // 上传前校检格式和大小
    handleBeforeUpload(file) {
      // 校检文件大小
      if (this.fileSize) {
        const isLt = file.size / 1024 / 1024 < this.fileSize;
        if (!isLt) {
          this.$message.error(`上传文件大小不能超过 ${this.fileSize} MB!`);
          return false;
        }
      }
      return true;
    },
    handleUploadSuccess(res, file) {
      // 获取富文本组件实例
      let quill = this.Quill;
      // 如果上传成功
      if (res.code == 200) {
        // 获取光标所在位置
        this.form.imgUrl = res.data.src
        this.$forceUpdate()
      } else {
        this.$message.error("图片插入失败");
      }
    },
    handleUploadError() {
      this.$message.error("图片插入失败");
    },
    /** 查询衣服颜色列表 */
    getList() {
      this.$nextTick(() => {
        this.$refs.pagination.handleSearch(true)
      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        name: null,
        code: null,
        colorType: '0',
        sort: null,
        status: "0",
        delFlag: null,
        createBy: null,
        createById: null,
        createTime: null,
        updateBy: null,
        updateById: null,
        updateTime: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加衣服颜色";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getColor(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改衣服颜色";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          console.log(this.form);
          if (this.form.id != null) {
            updateColor(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addColor(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除衣服颜色名称为"' + row.name + '"的数据项？').then(function () {
        return delColor(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    // 衣服颜色状态修改
    handleStatusChange(row) {
      let text = row.status === "0" ? "启用" : "停用";
      this.$modal.confirm('确认要' + text + ' ' + row.name + ' 吗？').then(function () {
        return changeColorStatus(row.id, row.status);
      }).then(() => {
        this.$modal.msgSuccess(text + "成功");
      }).catch(function () {
        row.status = row.status === "0" ? "1" : "0";
      });
    },
    checkClose(done) {
      this.$confirm('是否关闭表单，关闭后数据将丢失？').then(function () {
        done()
      }).then(() => { }).catch(() => { });
    },
    onDialogOpened() {
      if (this.id != undefined && this.id != '') {
        this.dialogLoading = true
        this.loadingText = '查询中'
        getColor(this.id).then(res => {
          this.formData = res.data

          this.resetForm('elForm')
        }).catch(e => {
          this.dialogLoading = false
          this.$message.error(e.data.msg)
        })
      } else {
        this.dialogLoading = false
      }
    },
    closeDialog() {
      this.open = false
    }

  }
};
</script>
